import { FunctionDefinition, FunctionDefinitionHandler } from "serverless";
import Service from "serverless/classes/Service";
export declare enum RuntimeType {
    NODE = "node",
    PYTHON = "python",
    DOTNET = "dotnet",
    CUSTOM = "custom",
    JAVA = "java",
    RUBY = "ruby",
    GO = "go",
    UNSUPPORTED = "unsupported"
}
export interface FunctionInfo {
    name: string;
    type: RuntimeType;
    handler: ExtendedFunctionDefinition;
    runtime?: string;
}
export interface ExtendedFunctionDefinition extends FunctionDefinition {
    architecture?: string;
}
export interface LayerJSON {
    regions: {
        [region: string]: {
            [runtime: string]: string | undefined;
        } | undefined;
    };
}
export declare const runtimeLookup: {
    [key: string]: RuntimeType;
};
export declare const armRuntimeKeys: {
    [key: string]: string;
};
export declare function findHandlers(service: Service, exclude: string[], defaultRuntime?: string): FunctionInfo[];
export declare function applyLambdaLibraryLayers(service: Service, handlers: FunctionInfo[], layers: LayerJSON, accountId?: string): void;
export declare function applyExtensionLayer(service: Service, handlers: FunctionInfo[], layers: LayerJSON, accountId?: string): void;
export declare function applyTracingLayer(service: Service, handler: FunctionInfo, layers: LayerJSON, runtimeKey: string, accountId?: string): void;
export declare function pushLayerARN(layerARN: string, currentLayers: string[]): string[];
export declare function isFunctionDefinitionHandler(funcDef: FunctionDefinition): funcDef is FunctionDefinitionHandler;
//# sourceMappingURL=layer.d.ts.map